'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Gradient = function Gradient(_ref) {
  var primaryColor = _ref.primaryColor,
      primaryOffset = _ref.primaryOffset,
      secondaryColor = _ref.secondaryColor,
      secondaryOffset = _ref.secondaryOffset;

  return _react2.default.createElement(
    'defs',
    null,
    _react2.default.createElement(
      'linearGradient',
      { id: 'full' },
      _react2.default.createElement('stop', { offset: '100%', stopColor: primaryColor })
    ),
    _react2.default.createElement(
      'linearGradient',
      { id: 'none' },
      _react2.default.createElement('stop', { offset: '100%', stopColor: secondaryColor })
    ),
    _react2.default.createElement(
      'linearGradient',
      { id: 'half' },
      _react2.default.createElement('stop', { offset: primaryOffset + '%', stopColor: primaryColor }),
      _react2.default.createElement('stop', { offset: secondaryOffset + '%', stopColor: secondaryColor })
    )
  );
};

Gradient.propTypes = {
  primaryColor: _propTypes2.default.string.isRequired,
  primaryOffset: _propTypes2.default.number.isRequired,
  secondaryColor: _propTypes2.default.string.isRequired,
  secondaryOffset: _propTypes2.default.number.isRequired
};

exports.default = Gradient;