'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _star = require('./star');

var _star2 = _interopRequireDefault(_star);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactStarsRating = function (_PureComponent) {
  _inherits(ReactStarsRating, _PureComponent);

  function ReactStarsRating(props) {
    _classCallCheck(this, ReactStarsRating);

    var _this = _possibleConstructorReturn(this, (ReactStarsRating.__proto__ || Object.getPrototypeOf(ReactStarsRating)).call(this, props));

    _this.state = {
      value: props.value
    };

    _this.onMouseMove = _this.onMouseMove.bind(_this);
    _this.onMouseLeave = _this.onMouseLeave.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(ReactStarsRating, [{
    key: 'isMoreThanHalf',
    value: function isMoreThanHalf(event) {
      var size = this.props.size;

      var point = event.clientX - event.target.getBoundingClientRect().left;

      return point > size / 2;
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(event) {
      var isHalf = this.props.isHalf;


      var value = Number(event.target.getAttribute('data-stars'));

      if (isHalf) {
        var isMoreThanHalf = this.isMoreThanHalf(event);

        if (!isMoreThanHalf) {
          value -= 0.5;
        }
      }

      this.setState({ value: value });
    }
  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave() {
      this.setState({ value: 0 });
    }
  }, {
    key: 'onBlur',
    value: function onBlur() {
      var onChange = this.props.onChange;
      var value = this.state.value;


      onChange(value);
    }
  }, {
    key: 'onChange',
    value: function onChange(event) {
      var _props = this.props,
          onChange = _props.onChange,
          isHalf = _props.isHalf;


      var value = Number(event.target.getAttribute('data-stars'));

      if (isHalf) {
        var isMoreThanHalf = this.isMoreThanHalf(event);

        if (!isMoreThanHalf) {
          value -= 0.5;
        }
      }

      onChange(value);
    }
  }, {
    key: 'onChangeStars',
    value: function onChangeStars(newValue) {
      var value = this.state.value;
      var count = this.props.count;


      if (value > 0 && newValue < 0 || value < count && newValue > 0) {
        value += newValue;

        this.setState({ value: value });
      }
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(event) {
      var keyCode = event.keyCode;
      var value = this.state.value;
      var _props2 = this.props,
          isHalf = _props2.isHalf,
          onChange = _props2.onChange;


      switch (keyCode) {
        case 37:
          this.onChangeStars(isHalf ? -0.5 : -1);
          break;
        case 39:
          this.onChangeStars(isHalf ? 0.5 : 1);
          break;
        case 13:
          onChange(value);
          break;
        default:
          break;
      }
    }
  }, {
    key: 'renderStars',
    value: function renderStars() {
      var _props3 = this.props,
          count = _props3.count,
          size = _props3.size,
          isHalf = _props3.isHalf,
          isEdit = _props3.isEdit,
          primaryColor = _props3.primaryColor,
          secondaryColor = _props3.secondaryColor;
      var value = this.state.value;

      var starsList = [];
      var props = { primaryColor: primaryColor, secondaryColor: secondaryColor, isEdit: isEdit };

      if (isEdit) {
        props = _extends({}, props, {
          onMouseMove: this.onMouseMove,
          onMouseLeave: this.onMouseLeave,
          onChange: this.onChange
        });
      }

      for (var i = 1; i <= count; i++) {
        starsList.push(_react2.default.createElement(
          'span',
          { key: 'react-stars-rating-char' + i },
          _react2.default.createElement(_star2.default, _extends({
            index: i,
            value: value,
            size: size,
            isHalf: isHalf
          }, props))
        ));
      }

      return starsList;
    }
  }, {
    key: 'render',
    value: function render() {
      var isEdit = this.props.isEdit;

      var stars = this.renderStars();
      var props = { tabIndex: -1 };

      if (isEdit) {
        props = {
          onKeyDown: this.onKeyDown,
          onBlur: this.onBlur
        };
      }

      return _react2.default.createElement(
        'button',
        _extends({ type: 'button', style: _styles2.default.container }, props),
        stars
      );
    }
  }]);

  return ReactStarsRating;
}(_react.PureComponent);

ReactStarsRating.propTypes = {
  onChange: _propTypes2.default.func,
  count: _propTypes2.default.number.isRequired,
  value: _propTypes2.default.number.isRequired,
  size: _propTypes2.default.number.isRequired,
  primaryColor: _propTypes2.default.string.isRequired,
  secondaryColor: _propTypes2.default.string.isRequired,
  isEdit: _propTypes2.default.bool.isRequired,
  isHalf: _propTypes2.default.bool.isRequired
};

ReactStarsRating.defaultProps = {
  isEdit: true,
  isHalf: true,
  count: 5,
  value: 0,
  size: 25,
  primaryColor: 'yellow',
  secondaryColor: 'grey'
};

exports.default = ReactStarsRating;