'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _gradient = require('./gradient');

var _gradient2 = _interopRequireDefault(_gradient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var StarSVG = function StarSVG(_ref) {
  var viewBox = _ref.viewBox,
      size = _ref.size,
      onMouseMove = _ref.onMouseMove,
      onMouseLeave = _ref.onMouseLeave,
      onChange = _ref.onChange,
      index = _ref.index,
      value = _ref.value,
      isHalf = _ref.isHalf,
      primaryColor = _ref.primaryColor,
      secondaryColor = _ref.secondaryColor,
      fill = _ref.fill,
      isEdit = _ref.isEdit,
      primaryOffset = _ref.primaryOffset,
      secondaryOffset = _ref.secondaryOffset;

  if (isEdit) {
    if (index <= value) {
      fill = 'url(#full)';
    } else if (isHalf && index - 0.5 === value) {
      fill = 'url(#half)';
    }
  } else {
    if (index === 1) {
      var rest = value - Math.floor(value) || 1;
      primaryOffset = Math.round(rest * 100);
    }
    var ceilValue = Math.ceil(value);
    if (index < value) {
      fill = 'url(#full)';
    } else if (isHalf && index === ceilValue) {
      fill = 'url(#half)';
    }
  }

  var props = {
    primaryColor: primaryColor,
    primaryOffset: primaryOffset,
    secondaryColor: secondaryColor,
    secondaryOffset: secondaryOffset
  };

  return _react2.default.createElement(
    'svg',
    {
      width: size,
      viewBox: viewBox,
      xmlns: 'http://www.w3.org/2000/svg',
      xmlnsXlink: 'http://www.w3.org/1999/xlink',
      onMouseLeave: onMouseLeave,
      onClick: onChange,
      'data-stars': index,
      onMouseMove: onMouseMove
    },
    index === 1 && _react2.default.createElement(_gradient2.default, props),
    _react2.default.createElement('polygon', {
      fill: fill,
      points: '153,230.775 247.35,299.625 211.65,187.425 306,121.125 191.25,121.125 153,6.375 114.75,121.125 0,121.125  94.35,187.425 58.65,299.625',
      pointerEvents: 'none'
    })
  );
};

StarSVG.propTypes = {
  viewBox: _propTypes2.default.string,
  size: _propTypes2.default.number.isRequired,
  primaryColor: _propTypes2.default.string.isRequired,
  secondaryColor: _propTypes2.default.string.isRequired,
  onMouseLeave: _propTypes2.default.func,
  onMouseMove: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  isHalf: _propTypes2.default.bool.isRequired,
  fill: _propTypes2.default.string,
  index: _propTypes2.default.number.isRequired,
  value: _propTypes2.default.number.isRequired,
  isEdit: _propTypes2.default.bool.isRequired,
  primaryOffset: _propTypes2.default.number.isRequired,
  secondaryOffset: _propTypes2.default.number.isRequired
};

StarSVG.defaultProps = {
  viewBox: '0 0 306 306',
  fill: 'url(#none)',
  primaryOffset: 50,
  secondaryOffset: 50
};

exports.default = StarSVG;